package ryulib.game;

import ryulib.OnHandlerMessageListener;
import android.graphics.Bitmap;
import android.graphics.Bitmap.Config;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Rect;
import android.os.Handler;
import android.os.Message;

public class GamePlatformInfo {

	public GamePlatformInfo() {
		super();
		
		_Paint.setAntiAlias(true);
	}

	GameMessageList _GameMessageList = new GameMessageList();
	GameMessage _GameMessage = null;

	private Bitmap _Bitmap = Bitmap.createBitmap(1, 1, Config.ARGB_8888);
	private Canvas _Canvas = new Canvas();
	private Paint _Paint = new Paint();
	private long _Tick = 0;
	
	private Handler _Handler = new Handler() {		
		public void handleMessage(Message msg) {
			if (_OnHandlerMessage != null) _OnHandlerMessage.onReceived(msg);
		}
	};
	
	synchronized void setSize(int width, int height) {
		  _Bitmap = Bitmap.createBitmap(width, height, Config.ARGB_8888);
		  _Canvas.setBitmap(_Bitmap);
	}
	
	synchronized void Draw(Canvas canvas) {
		canvas.drawBitmap(_Bitmap, 0, 0, _Paint);
	}
	
	private static final int _TickLimit = 500;

	void setTick(long value) {
		// Tick  ʹ ũٸ ̰ų     ִ.  
		// ̶,  ̿     Ƿ Term ũ⸦ Ѵ.
		if (value > _TickLimit) value = _TickLimit;

		_Tick = value;
	}

	private OnHandlerMessageListener _OnHandlerMessage = null;
	
	void setOnHandlerMessage(OnHandlerMessageListener value) {
		_OnHandlerMessage = value;
	}

	public void AddMessage(GameMessage gameMessage) {
		_GameMessageList.Add(gameMessage);
	}
	
	public void AddMessage(Object sender, int what) {
		GameMessage gameMessage = new GameMessage();
		gameMessage.sender = sender;
		gameMessage.what = what;
		
		_GameMessageList.Add(gameMessage);
	}
	
	public void AddMessage(Object sender, String str) {
		GameMessage gameMessage = new GameMessage();
		gameMessage.sender = sender;
		gameMessage.str = str;
		
		_GameMessageList.Add(gameMessage);
	}
	
	public Bitmap getBitmap() {
		return _Bitmap;
	}

	public Canvas getCanvas() {
		return _Canvas;
	}
	
	public Paint getPaint() {
		return _Paint;
	}
	
	public GameMessage getGameMessage() {
		return _GameMessage;
	}
	
	public Handler getHandler() {
		return _Handler;
	}
	
	public long getTick() {
		return _Tick;
	}
	
	private Rect _Rect = new Rect();
	
	public Rect getRect() {
		_Rect.left = 0;
		_Rect.top = 0;
		_Rect.right = _Canvas.getWidth();
		_Rect.bottom = _Canvas.getHeight();
		
		return _Rect;
	}
	
}
